{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X-}
{$M 16384,0,655360}
unit hrac2;

interface

uses typy;

  procedure Tahaj(Ihr: E_Ihrisko; var Panaky: E_Panaciky);
  procedure Init;

implementation

const
  Utekaj  = $1;
  O1Poloz = $2;
  UHore   = $4;
  UVpravo = $8;
  UDole   = $10;
  UVlavo  = $20;

  Farba   = 2;

var
  Bomby: array[1..IhriskoX, 1..IhriskoY] of integer;

  Hraci: array[1..Panacikov] of Byte;


procedure Init;
begin
  FillChar(Bomby, SizeOf(Bomby), #0);
  FillChar(Hraci, SizeOf(Hraci), #1);
end;

procedure Tahaj;
var
  mysmer,maxroz,maxsm,i,j,Nasich,my,oni,pocsup,MS1,MS2,k:Integer;

  procedure PolozBombu(X, Y, Sirka, Cas: Byte);
  var
    i, j: integer;
  begin
    for i :=-sirka to sirka do
     for j:=-sirka to sirka do
      if (abs(i+j)<=sirka) then
       if ((x+i)>0) and ((x+i)<=IhriskoX) and ((y+j)>0) and ((y+j)<=IhriskoY) then
        Bomby[x+i,y+j]:=Cas;
     Inc(Bomby[x,y],Bomba);
  end;


  procedure Dookola(x, y, sila: byte; var my, oni: integer);
  var
    i, j: integer;
  begin
    my:=0; oni:=0;
    for i :=-sila to sila do
     for j:=-sila to sila do
      if (abs(i+j)<=sila) then
       if ((x+i)>0) and ((x+i)<=IhriskoX) and ((y+j)>0) and ((y+j)<=IhriskoY) then
        if Ihr[x+i,y+j]=farba then Inc(my)
                              else if Ihr[x+i,y+j] in [1..Hracov] then
                                   Inc(oni);
  end;

  procedure Utec(Panacik: Byte);
  var
    sm,ism: shortint;
    MyX,MyY,MySmer,minpoc,minsm,poc:integer;
    minus:Boolean;
  begin
    minpoc:=255; minsm:=0; minus:=False;
    for ism:=0 to 2 do
    with Panaky[Panacik] do
    begin
      sm:= ism - 3 * Ord(ism=2);
      MySmer := (smer + 4 + sm) mod 4; poc:=0;
      MyX := px + smery[mysmer].x; MyY := py + smery[mysmer].y;
      while (MyX in [1..IhriskoX]) and (MyY in [1..IhriskoY]) and
            (Bomby[MyX,MyY]>0) do
      begin
        Inc(poc);
        MyX := MyX + smery[mysmer].x; MyY := MyY + smery[mysmer].y;
      end;
      if (MyX in [1..IhriskoX]) and (MyY in [1..IhriskoY]) then
      begin
       if poc<minpoc then
        begin
         if Bomby[MyX,MyY]=-1 then minus:=True;
         minsm:=sm;
         minpoc:=poc;
        end;
       if (poc=0) and minus and (Bomby[MyX,MyY]<>-1) then begin
                                  minus:=False;
                                  minsm:=sm
                                 end;
      end;
    end;
    Panaky[Panacik].zaboc:=minsm
  end;

begin
  for i:=1 to IhriskoX do
    for j:=1 to IhriskoY do
    begin
      if Bomby[i, j] > 0 then
        Dec(Bomby[i, j]);
      if Bomby[i, j] = Bomba then
        Bomby[i, j] := 0;
      if Bomby[i,j]=-1 then Bomby[i,j]:=0
    end;
  pocsup:=0;
  for i:=1 to IhriskoX do
    for j:=1 to IhriskoY do
    begin
      if (Ihr[i,j]=Bomba) and (Bomby[i,j]<Bomba) then PolozBombu(i,j,5,1);
      if (Ihr[i,j]>0) and (Ihr[i,j]<Bomba) then begin
                                                 Inc(pocsup);
                                                 if Bomby[i,j]=0 then
                                                 begin  Bomby[i,j]:=-1;
                                                 end;
                                                end;
    end;

  Nasich := 0;
  for i := 1 to Panacikov do
    if Panaky[i].zivy then
      Inc(Nasich);

  pocsup:=pocsup-Nasich;
  for i := 1 to Panacikov do
    if Panaky[i].Zivy then
    begin
      if (Hraci[i] and utekaj) > 0 then with Panaky[i] do
                                        begin
                                         Utec(i);
                                         MS1:=(smer+1+4) mod 4;
                                         MS2:=(smer-1+4) mod 4;
                               if ((px+smery[Ms1].x) in [1..IhriskoX]) and
                            ((py+smery[Ms1].y) in [1..IhriskoY]) and
                               ((px+smery[Ms2].x) in [1..IhriskoX]) and
                            ((py+smery[Ms2].y) in [1..IhriskoY]) then

                                         if (Bomby[px+smery[MS1].x,py+smery[MS1].y]=0)
                                         and (Bomby[px+smery[MS2].x,py+smery[MS2].y]=0) then
                                         begin
                                          k:=Random(10);
                                          if k=9 then zaboc:=-1+Random(2)*2;
                                         end;
                                        end;
      if (Hraci[i] and O1Poloz)>0 then with Panaky[i] do
      begin
       poloz:=5;
       Hraci[i]:=Hraci[i] and (not O1Poloz);
      end else
      if Nasich>2 then with Panaky[i] do
                       begin
                        maxroz:=-1; maxsm:=0;
                        for j:=-1 to 1 do
                        begin
                         MySmer := (smer + 4 + j) mod 4;
                         if ((px+smery[Mysmer].x) in [1..IhriskoX]) and
                            ((py+smery[Mysmer].y) in [1..IhriskoY]) then
                         begin
                          Dookola(px+smery[MySmer].x,py+smery[MySmer].x,3,my,oni);
                          if (oni-my)> maxroz then begin
                                                    maxroz:=oni-my;
                                                    maxsm:=j
                                                   end;
                         end;
                        end;
                        if (maxroz>0) or ((maxroz=0) and ((nasich-pocsup)>2) ) then begin
                                          MySmer := (smer +4 + maxsm) mod 4;
                                          PolozBombu(px,py,1,3);
                                          PolozBombu(px+smery[MySmer].x,
                                                     py+smery[MySmer].y,5,3);
                                          poloz:=1;
                                          Hraci[i]:=(Hraci[i] and (not O1Poloz)) + O1Poloz;
                                         end;
                       end;
  end;


end;

begin
end.