{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X-}
{$M 16384,0,655360}
unit hrac3;

interface

uses typy;
const faktor1=5;  { odhad sily bomb }
      faktor2=500; { pravdepodobnost zmeny smeru 1/faktor2}
      faktor3=1;  { pravdepodobnost polozenia bomby 1/faktor3}
      faktor4=1;  { minimalny pocet cudzich hracov v okoli polozenej bomby }
      faktor5=2;  { maximalny pocet vlastnych hracov v okoli polozenej bomby }
      faktor6=-1; { zaciatocna hodnota bomby }
      faktor7=-10;{ oznacenie prazdneho miesta na mape bomb faktor7<faktor6 ! }
var m:array[1..ihriskox,1..ihriskoy] of shortint;
procedure Init;
procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);

implementation
procedure Init;
var x,y:integer;
begin
for x:=1 to ihriskox do
    for y:=1 to ihriskoy do
        m[x,y]:=faktor7;
end;
procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);
var i,j,smer,px,py:integer;
    fx,fy,x,y:integer; {suradnice bomby ktorej sme v okoli }

procedure vpravo;
begin
smer:=smer+1;
if smer>3 then smer:=smer-4;
end;

procedure vlavo;
begin
smer:=smer-1;
if smer<0 then smer:=smer+4;
end;

procedure cvz;
begin
smer:=smer+2;
if smer>3 then smer:=smer-4;
end;

function Inside(sx,sy:integer):boolean;
{ zisti ci pozicia [sx,sy] sa nachadza v okoli nejakej bomby }
var x,y,qx,qy:integer;
begin
Inside:=false;
if sx>faktor1 then qx:=sx else qx:=faktor1+1;
if sx>ihriskox-faktor1 then qx:=ihriskox-faktor1;
if sy>faktor1 then qy:=sy else qy:=faktor1+1;
if sy>ihriskoy-faktor1 then qy:=ihriskoy-faktor1;
for x:=qx-faktor1 to qx+faktor1 do
    for y:=qy-faktor1 to qy+faktor1 do
        if m[x,y]<>0 then
                   if abs(sx-x)+abs(sy-y)<=m[x,y] then
              begin Inside:=true; fx:=x; fy:=y; exit; end;
end;

function Inside2(sx,sy:integer):boolean;
{ zisti ci pozicia [sx,sy] sa nachadza v celkovom okoli nejakej bomby }
var x,y,qx,qy:integer;
begin
Inside2:=false;
if sx>faktor1 then qx:=sx else qx:=faktor1+1;
if sx>ihriskox-faktor1 then qx:=ihriskox-faktor1;
if sy>faktor1 then qy:=sy else qy:=faktor1+1;
if sy>ihriskoy-faktor1 then qy:=ihriskoy-faktor1;
for x:=qx-faktor1 to qx+faktor1 do
    for y:=qy-faktor1 to qy+faktor1 do
        if m[x,y]>=faktor6 then
           if abs(sx-x)+abs(sy-y)<=faktor1 then
              begin Inside2:=true; fx:=x; fy:=y; exit; end;
end;

function Include(sx,sy,q:integer):boolean;
{ zisti ci v okoli bomby s poziciou [sx,sy] a silou q sa nachadza nejaka ina bomba }
var x,y,qx,qy:integer;
begin
Include:=false;
if sx>q then qx:=sx else qx:=q+1;
if sx>ihriskox-q then qx:=ihriskox-q;
if sy>q then qy:=sy else qy:=q+1;
if sy>ihriskoy-q then qy:=ihriskoy-q;
for x:=qx-q to qx+q do
    for y:=qy-q to qy+q do
        if m[x,y]>=faktor6 then
           if abs(sx-x)+abs(sy-y)<=q then
              begin Include:=true; exit; end;
end;

function Enemy(sx,sy,q:integer):byte;
{ zisti kolko je nepriatelov v okoli bomby s poziciou [sx,sy] a silou q }
var x,y,z,qx,qy:integer;
begin
z:=0;
if sx>q then qx:=sx else qx:=q+1;
if sx>ihriskox-q then qx:=ihriskox-q;
if sy>q then qy:=sy else qy:=q+1;
if sy>ihriskoy-q then qy:=ihriskoy-q;
for x:=qx-q to qx+q do
    for y:=qy-q to qy+q do
        if a[x,y] in [1,2,4] then
           if abs(sx-x)+abs(sy-y)<=q then z:=z+1;
Enemy:=z;
end;

function Own(sx,sy,q:integer):byte;
{ zisti kolko mame vlastnych hracov v okoli bomby s poziciou [sx,sy] a silou q }
var x,y,z,qx,qy:integer;
begin
z:=0;
if sx>q then qx:=sx else qx:=q+1;
if sx>ihriskox-q then qx:=ihriskox-q;
if sy>q then qy:=sy else qy:=q+1;
if sy>ihriskoy-q then qy:=ihriskoy-q;
for x:=qx-q to qx+q do
    for y:=qy-q to qy+q do
        if a[x,y]=3 then
           if abs(sx-x)+abs(sy-y)<=q then z:=z+1;
Own:=z;
end;

begin
fx:=0; fy:=0;
{ aktualizujeme mapu bomb }
for x:=1 to ihriskox do
    for y:=1 to ihriskoy do
        begin
        if (m[x,y]=faktor7) and (a[x,y]=bomba)
           then m[x,y]:=faktor6
           else
             begin
             if (m[x,y]>=faktor6) and (a[x,y]<>bomba) then m[x,y]:=faktor7;
             if (m[x,y]>=faktor6) and (a[x,y]=bomba) then inc(m[x,y]);
             end;
        end;
{ panacikovia }
for i:=1 to Panacikov do if JeZivy(b,i) then
    begin
    px:=b[i].px;
    py:=b[i].py;
    smer:=b[i].smer;
{ *** polozit bombu }
    { ak nie som v okoli ziadnej bomby }
    if not(inside2(px,py)) and (random(faktor3)=0) then
       begin
       j:=random(5)+1;
       repeat
       { ak po polozeni bomby sily j nebude mat tato bomba v okoli inu
         alebo v oblasti nebude dost cudzich alebo bude prilis vela vlatnych hracov }
       if not(include(px,py,j)) and (enemy(px,py,j)>=faktor4) and (own(px,py,j)<=faktor5)
          {and not(((px<=j) and (smer=3)) or ((px>=ihriskox-j) and (smer=1)) or
              ((py<=j) and (smer=0)) or ((py>=ihriskoy-j) and (smer=2)))} then
          begin Poloz(b,i,j); m[px,py]:=faktor6; j:=1; end;
       dec(j);
       until j=0;
       end;
{ zmenit smer }
    { ak som v okoli nejakej bomby }
    if inside2(px,py) then
       begin
       if (py=fy) and (px>fx) and (smer=1) then
          begin
          if not(inside(px+smery[0].x,py+smery[0].y)) and (py>1) then smer:=0
          else
          if not(inside(px+smery[1].x,py+smery[1].y)) and (px<ihriskox) then smer:=1
          else
          if not(inside(px+smery[2].x,py+smery[2].y)) and (py<ihriskoy) then smer:=2;
          end;
       if (py=fy) and (px<fx) and (smer=3) then
          begin
          if not(inside(px+smery[0].x,py+smery[0].y)) and (py>1) then smer:=0
          else
          if not(inside(px+smery[3].x,py+smery[3].y)) and (px>1) then smer:=3
          else
          if not(inside(px+smery[2].x,py+smery[2].y)) and (py<ihriskoy) then smer:=2;
          end;
       if (px=fx) and (py<fy) and (smer=2) then
          begin
          if not(inside(px+smery[3].x,py+smery[3].y)) and (px>1) then smer:=3
          else
          if not(inside(px+smery[2].x,py+smery[2].y)) and (py<ihriskoy) then smer:=2
          else
          if not(inside(px+smery[1].x,py+smery[1].y)) and (px<ihriskox) then smer:=1;
          end;
       if (px=fx) and (py<fy) and (smer=0) then
          begin
          if not(inside(px+smery[3].x,py+smery[3].y)) and (px>1) then smer:=3
          else
          if not(inside(px+smery[0].x,py+smery[0].y)) and (py>1) then smer:=0
          else
          if not(inside(px+smery[1].x,py+smery[1].y)) and (px<ihriskox) then smer:=1;
          end;
       if (px>fx) and (py>fy) then
          begin
          if smer=0 then smer:=1;
          if smer=3 then smer:=2;
          end;
       if (px>fx) and (py<fy) then
          begin
          if smer=3 then smer:=0;
          if smer=2 then smer:=1;
          end;
       if (px<fx) and (py<fy) then
          begin
          if smer=2 then smer:=3;
          if smer=1 then smer:=0;
          end;
       if (px<fx) and (py>fy) then
          begin
          if smer=0 then smer:=3;
          if smer=1 then smer:=2;
          end;
       end;
    { ak som v niektorom rohu }
    if (px=1) and (py=1) then
       begin
       if smer=3 then
          begin
          smer:=2;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=0;
          end;
       if smer=0 then
          begin
          smer:=1;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=3;
          end;
       end;
    if (px=ihriskox) and (py=1) then
       begin
       if smer=0 then
          begin
          smer:=3;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=1;
          end;
       if smer=1 then
          begin
          smer:=2;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=0;
          end;
       end;
    if (px=ihriskox) and (py=ihriskoy) then
       begin
       if smer=1 then
          begin
          smer:=0;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=2;
          end;
       if smer=2 then
          begin
          smer:=3;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=1;
          end;
       end;
    if (px=1) and (py=ihriskoy) then
       begin
       if smer=2 then
          begin
          smer:=1;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=3;
          end;
       if smer=3 then
          begin
          smer:=0;
          if inside(px+smery[smer].x,py+smery[smer].y) then smer:=2;
          end;
       end;
    { ak som narazil do steny }
    if px=1 then
       if smer=3 then
          if random(2)=0 then
             begin
             smer:=2;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (py=ihriskoy) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=0;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=3;
                end;
             end
          else
             begin
             smer:=0;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (py=1) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=2;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=3;
                end;
             end;
    if px=ihriskox then
       if smer=1 then
          if random(2)=0 then
             begin
             smer:=0;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (py=1) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=2;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=1;
                end;
             end
          else
             begin
             smer:=2;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (py=ihriskoy) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=0;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=1;
                end;
             end;
    if py=1 then
       if smer=0 then
          if random(2)=0 then
             begin
             smer:=3;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (px=1) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=1;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=0;
                end;
             end
          else
             begin
             smer:=1;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (px=ihriskox) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=3;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=0;
                end;
             end;
     if py=ihriskoy then
        if smer=2 then
          if random(2)=0 then
             begin
             smer:=1;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (px=ihriskox) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=3;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=2;
                end;
             end
          else
             begin
             smer:=3;
             if (inside(px+smery[smer].x,py+smery[smer].y)) or (px=1) or
                (a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4]) then
                begin
                smer:=1;
                if inside(px+smery[smer].x,py+smery[smer].y) then
                   if inside2(px,py) then smer:=2;
                end;
             end;
     { *** ak niekto mi stoji v ceste }
     if (px+smery[smer].x>0) and (px+smery[smer].x<=ihriskox) and
        (py+smery[smer].y>0) and (py+smery[smer].y<=ihriskoy) then
        begin
        if a[px+smery[smer].x,py+smery[smer].y] in [1,2,3,4,bomba] then
           begin
           if random(2)=0 then
              begin
              vlavo;
              if (px+smery[smer].x<1) or (px+smery[smer].x>ihriskox) then cvz;
              if (py+smery[smer].y<1) or (py+smery[smer].y>ihriskoy) then cvz;
              if inside(px+smery[smer].x,py+smery[smer].y) then cvz;
              end
           else
              begin
              vpravo;
              if (px+smery[smer].x<1) or (px+smery[smer].x>ihriskox) then cvz;
              if (py+smery[smer].y<1) or (py+smery[smer].y>ihriskoy) then cvz;
              if inside(px+smery[smer].x,py+smery[smer].y) then cvz;
              end;
           end;
        end;
     { ak niet nebezpecenstva }
     case random(faktor2) of
          0: begin smer:=smer-1; if smer=-1 then smer:=3; end;
          1: begin smer:=smer+1; if smer=4 then smer:=0; end;
          end;
     { ak chcem stupit do okolia nejakej bomby }
     if (px+smery[smer].x>0) and (px+smery[smer].x<=ihriskox) and
        (py+smery[smer].y>0) and (py+smery[smer].y<=ihriskoy) then
        begin
        if not(inside2(px,py)) and inside2(px+smery[smer].x,py+smery[smer].y) then
           begin
           if random(2)=0 then
              begin
              vlavo;
              if inside(px+smery[smer].x,py+smery[smer].y) then cvz;
              end
           else
              begin
              vpravo;
              if inside(px+smery[smer].x,py+smery[smer].y) then cvz;
              end;
           end;
        end;
     { nastavime smer otacania }
     case smer-b[i].smer of
          -1: dolava(b,i);
           3: dolava(b,i);
           1: doprava(b,i);
          -3: doprava(b,i);
           end;
     end;
 end;

begin
end.