  unit grafika;

interface
  uses nanimate,graph,typy,crt,vgaemul;

  procedure VybuchniBombu(var A:I_Ihrisko;X,Y,Sila:integer);
  procedure NakresliBombu(Sila,X,Y:word);
  procedure VymazBombu(X,Y:word);
  procedure NakresliPanacika(Hrac,X,Y:word);
  procedure VymazPanacika(Hrac,X,Y:word);
  procedure OznamZapas(H1,H2:word);
  procedure NakresliIhrisko;
  procedure OznamVysledok(H1,H2,b1,b2:integer;w:string);
  procedure KoniecTurnaja(a:Vysledok);

implementation
  var i,j,k:word;
      d,m:integer;

  const sizex=42;
        sizey=20;
        dx=9;
        dy=12;
        pnt=true;

  procedure VybuchniBombu(var A:I_Ihrisko;X,Y,Sila:integer);
    var px,py:word;
        i,j,k,l:integer;
  begin
    if pnt then begin
      if Card=0 then l:=0 else l:=4;
      for k:=l to 5 do begin
        for i:=-Sila to Sila do begin
          for j:=-Sila to Sila do begin
            if (x+i>=1) and (y+j>=1) and (x+i<=IhriskoX) and (y+j<=IhriskoY) and (abs(i)+abs(j)<=sila) then begin
              px:=x+i; py:=y+j;
              if k>0 then begin
                xpaint((px+py*320)*10-321*10,k+9,21+(px+py) mod 2,0);
                if (A[px,py].hrac>0) then begin
                  if A[px,py].bomba>0 then begin
                    if (k mod 2=0) then NakresliBombu(A[px,py].bomba,px,py);
                    if (k mod 2=1) then VymazBombu(px,py);
                  end else begin
                    if (k mod 2=0) then NakresliPanacika(A[px,py].hrac,px,py);
                    if (k mod 2=1) then VymazPanacika(A[px,py].hrac,px,py);
                  end;
                end;
              end;
              if k<5 then paint((px+py*320)*10-321*10,k+10);
            end;
          end;
        end;
        delay(45);
      end;
    end;
  end;

  procedure NakresliBombu(Sila,X,Y:word);
    begin
      if pnt then paint(X*10+Y*320*10-321*10,Sila+4);
    end;

  procedure VymazBombu(X,Y:word);
    begin
      if pnt then winfill(x*10+y*10*320-321*10,10,10,21+(x+y) mod 2);
    end;

  procedure NakresliPanacika(Hrac,X,Y:word);
    begin
      if pnt then paint(X*10+Y*320*10-321*10,Hrac-1);
    end;

  procedure VymazPanacika(Hrac,X,Y:word);
    begin
      if pnt then winfill(x*10+y*10*320-321*10,10,10,21+(x+y) mod 2);
    end;

  procedure OznamZapas(H1,H2:word);
  begin
    if pnt then begin
      ClearScreen;
      bsettext(15,15,15,15,15,15,15,15,false,0);
      text(320*86+80,'Hraj hri :');
      bsettext(fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],false,0);
      text(320*106+210,fn[h1]);
      bsettext(fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],false,0);
      text(320*106+260,fn[h2]);
    end else write('Testing ',h1,' ',h2,' ');
  end;

  procedure OznamVysledok(H1,H2,b1,b2:integer;w:string);
  var s,z:string[10];
  begin
    if pnt then begin
      ClearScreen;
      str(b1:2,s);
      str(b2:2,z);
      bsettext(15,15,15,15,15,15,15,15,false,0);
      text(320*86+80,w);
      text(320*106+90,'   :   ');
      bsettext(fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],fa[h1],false,0);
      text(320*106+210,fn[h1]);
      text(320*106+90,s+'     ');
      bsettext(fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],fa[h2],false,0);
      text(320*106+260,fn[h2]);
      text(320*106+90,'     '+z);
    end;
  end;

  procedure NakresliIhrisko;
    var i,j:word;
  begin
    if pnt then begin
      for i:=1 to 20 do for j:=1 to 20 do begin
        winfill(i*10+j*10*320-321*10,10,10,21+(i+j) mod 2);
      end;
    end;
  end;

  procedure KoniecTurnaja(a:Vysledok);
    var i,j:word;
        s,z,t,u:string[10];
        Spolu:array[1..Hracov] of integer;
  begin
    if pnt then begin
      ClearScreen;
      for i:=1 to Hracov do begin
        bsettext(fa[i],fa[i],fa[i],fa[i],fa[i],fa[i],fa[i],fa[i],false,0);
        text(i*sizex+dx+320*dy,fn[i]);
        text(dx+320*dy+320*sizey*i,fn[i]);
      end;
      for i:=0 to Hracov+2 do begin
        lin(i*sizex+5,5,i*sizex+5,sizey*(Hracov+1)+5,15);
        lin(i*sizex+5+1,5,i*sizex+5+1,sizey*(Hracov+1)+5,7);
      end;
      for i:=0 to Hracov+1 do begin
        lin(5,5+i*sizey,5+sizex*(Hracov+2),5+i*sizey,15);
        lin(5,5+i*sizey+1,5+sizex*(Hracov+2),5+i*sizey+1,7);
      end;
      for i:=1 to Hracov do begin
        Spolu[i]:=0;
        for j:=1 to Hracov do begin
          if i=j then begin
            bsettext(1,1,1,1,1,1,1,1,false,0);
            text(i*sizex+dx+320*dy+320*sizey*i+3,'V U B');
          end else begin
            Spolu[i]:=Spolu[i]+a[i][j];
            bsettext(15,15,15,15,15,15,15,15,false,0);
            str(a[i][j]:2,s); {Kolko ziskal i-ty z j-tym}
            str(a[j][i]:2,z);
            text(i*sizex+dx+320*dy+320*sizey*j+3,z+':'+s);
            text(j*sizex+dx+320*dy+320*sizey*i+3,s+':'+z);
          end;
        end;
      end;
      for i:=1 to Hracov do begin
        bsettext(5,5,5,5,5,5,5,5,false,0);
        str(Spolu[i]:3,s);
        text((Hracov+1)*sizex+dx+320*dy+320*sizey*i,' '+s);
      end;
    end else writeln('Ready to run!');
  end;

begin
  if pnt then begin
    case Card of
      0:begin
        binit;
        bsetwpage(0);
        bloadpic('proboj.spr');
      end;
      1:begin
        d:=3;
        m:=1;
        initgraph(d,m,'d:\bp70\bgi');
        bloadpic('proboj.spr');
      end;
    end;
    ClearScreen;
  end;
end.