{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R+,S+,V-,X-}
{$M 16384,0,655360}
  unit hrac1;

interface
  uses typy;

  type
    TPole = record
              Objekt,
              Sila,Cas : integer;
            end;
    TMapa = array[1..20,1..20] of TPole;

  var
    Mapa : TMapa;

  procedure Init;
  procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);

implementation
const
  Nas = 1;

  procedure Init;
  var
    Cikl1,Cikl2 : byte;
  begin
    for Cikl1:=1 to 20 do
      for Cikl2:=1 to 20 do with Mapa[Cikl1,Cikl2] do begin
        Objekt:=0;
        Sila:=0;Cas:=0
      end;
  end;

  procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);
  var
    Men : integer;

    procedure RefreshMap;
    var
      Cikl1,Cikl2 : byte;
    begin
      Men:=0;
      for Cikl1:=1 to 20 do
        for Cikl2:=1 to 20 do with Mapa[Cikl1,Cikl2] do begin

          {*** Cas vybuchu bomby ***} 
          if Objekt=Bomba then dec(Cas);

          {*** Mapa sa zmenila ***}
          if A[Cikl1,Cikl2]<>Objekt then begin
            Objekt:=A[Cikl1,Cikl2];
            if Objekt=Bomba then begin
              Sila:=5;
              Cas:=1;    {***}
            end;
          end;

          {*** Pocitanie ludi ***}
          if A[Cikl1,Cikl2]=Nas then inc(Men);

        end;
    end;

    procedure ScoreMap;
    var
      Cikl1,Cikl2 : byte;
      Kx,Ky: integer;
    begin
      for Cikl1:=1 to 20 do
        for Cikl2:=1 to 20 do
          A[Cikl1,Cikl2]:=0;

      for Cikl1:=1 to 20 do
        for Cikl2:=1 to 20 do with Mapa[Cikl1,Cikl2] do begin
          if Objekt<>0 then begin
            inc(A[Cikl1,Cikl2],50);
            case Objekt of
              nas : begin
                      for Kx:=-3 to 3 do begin
                        if (Kx+Cikl1>=1) and (Kx+Cikl1<=20) then begin
                          for Ky:=-3 to 3 do begin

                            if (Ky+Cikl2>=1) and (Ky+Cikl2<=20) then
                            if (abs(Kx)+abs(Ky))<=3 then
                              A[Cikl1+Kx,Cikl2+Ky]:=
                                A[Cikl1+Kx,Cikl2+Ky]+(4-(abs(Kx)+abs(Ky)));
                          end;
                        end;
                      end;
                    end;
              2,3,4 : begin
                      for Kx:=-7 to 7 do begin
                        if (Kx+Cikl1>=1) and (Kx+Cikl1<=20) then
                        for Ky:=-7 to 7 do begin
                          if (Ky+Cikl2>=1) and (Ky+Cikl2<=20) then
                          if (abs(Kx)+abs(Ky))<=7 then
                            A[Cikl1+Kx,Cikl2+Ky]:=
                              A[Cikl1+Kx,Cikl2+Ky]-(8-(abs(Kx)+abs(Ky)));
                        end;
                      end;
                    end;
              else    begin
                        for Kx:=-5 to 5 do begin
                          if (Kx+Cikl1>=1) and (Kx+Cikl1<=20) then
                          for Ky:=-5 to 5 do begin
                            if (Ky+Cikl2>=1) and (Ky+Cikl2<=20) then
                            if (abs(Kx)+abs(Ky))<=5 then
                              A[Cikl1+Kx,Cikl2+Ky]:=
                                A[Cikl1+Kx,Cikl2+Ky]+(5-(abs(Kx)+abs(Ky)));
                          end;
                        end;
                      end;
            end;
          end;
        end;
    end;

    procedure DropBomb(Man : integer ; x, y, Power : byte);
    begin
      with Mapa[x,y] do begin
        Objekt:=Bomba;
        Sila:=Power;
        Cas:=Power+2
      end;
      ScoreMap;
      B[Man].Poloz:=Power
    end;

    procedure CtrlMan(Man : integer ; x, y : byte);

      function OpSmer(Sm : byte) : byte;
      var
        Res : shortint;
      begin
        case Sm of
          0 : Res:=2;
          1 : Res:=3;
          2 : Res:=0;
          3 : Res:=1;
        end;
        OpSmer:=Res;
      end;

    var
      Cikl : byte;
      Smest, BSmer : integer;
      Sila : integer;

    begin
      Smest:=0;
      for Cikl:=0 to 3 do begin
        if (x+Smery[Cikl].x>20) or (y+Smery[Cikl].y>20) or
           (Cikl=OpSmer(B[Man].Smer)) then begin end
        else begin

          if (x+Smery[Cikl].x>=1) and (x+Smery[Cikl].x<=20) and
             (y+Smery[Cikl].y>=1) and (y+Smery[Cikl].y<=20) then
          if A[x+Smery[Cikl].x , y+Smery[Cikl].y]-5<Smest then begin
            Smest:=A[x+Smery[Cikl].x , y+Smery[Cikl].y]-20; {***}
            BSmer:=Cikl;
          end;
        end;
      end;

      if B[Man].Smer<>BSmer then
        if (B[Man].Smer<BSmer) or (B[Man].Smer-BSmer=2)
          then Doprava(B,Man)
          else Dolava(B,Man);

      if A[x,y]-50<=0 then begin
        Sila:=abs(A[x,y]-51);
        if Sila>5 then Sila:=5;
        DropBomb(Man,B[Man].px,B[Man].py,5-Sila );
      end;
    end;

    var i:integer;
    begin
      RefreshMap;
      ScoreMap;

      for i:=1 to Panacikov do if JeZivy(b,i) then CtrlMan(i,b[i].px,b[i].py);

    end;

  begin
  end.
