  unit vgaemul;

  interface
    uses nanimate,graph;

  const VGA=0;
        EGA=1;
        card=VGA;

  procedure winfill(adr,sizex,sizey:word;col:byte);
  procedure paint(adr:word;co:integer);
  procedure xpaint(adr:word;co:integer;col,curn:byte);
  procedure text(adr:word;s:string);
  procedure ClearScreen;
  procedure lin(x1,y1,x2,y2:integer;col:byte);

  implementation

  {ZAKLADNA PROCEDURA PAINT}
  procedure epaint(adr:word;co:picture);
    begin
      asm
        cld
        push ds
        mov di,adr
        mov ds,co.wseg
        mov si,co.wofs
        mov bx,[ds:si]
        inc si
        inc si
        {NACITAJ POCET NUL}
   @dal:mov cx,[ds:si]
        add di,cx
        inc si
        inc si
        {NACITAJ POCET NENUL}
        mov cl,byte ptr [ds:si]
        mov ch,0h
        inc si
        sub bx,3d
        sub bx,cx
  @loop:

        push ax
        push bx
        push dx
   @sem:push cx
        mov ax,di
        mov dx,0
        mov bx,320
        div bx
        mov cx,ax
        xchg dx,cx
        mov ah,0ch
        mov bh,0h
        mov al,[ds:si]
        int 10h
        pop cx
        inc si
        inc di
        loop @sem
        pop dx
        pop bx
        pop ax

        {rep movsb}
        cmp bx,0h
        jne @dal
        pop ds
      end;
    end;

  {ZAKLADNA PROCEDURA XPAINT}
  procedure expaint(adr:word;co:picture;col,curn:byte);
    begin
      asm
        cld
        push ds
        mov di,adr
        mov ds,co.wseg
        mov si,co.wofs
        mov bx,[ds:si]
        inc si
        inc si
        {NACITAJ POCET NUL}
   @dal:mov cx,[ds:si]
        add di,cx
        inc si
        inc si
        {NACITAJ POCET NENUL}
        mov cl,byte ptr [ds:si]
        mov ch,0h
        inc si
        sub bx,3d
        sub bx,cx
  @loop:

        push ax
        push bx
        push dx
   @sem:push cx
        mov ax,di
        mov dx,0
        mov bx,320
        div bx
        mov cx,ax
        xchg dx,cx
        mov ah,0ch
        mov bh,0h
        mov al,col
        int 10h
        pop cx
        inc si
        inc di
        loop @sem
        pop dx
        pop bx
        pop ax

        {rep movsb}
        cmp bx,0h
        jne @dal
        pop ds
      end;
    end;

{POMOCNA PROCEDURA}
procedure eypis(qx:word;zn:word);
 var kam,kseg,kofs,qseg,qofs,sizex2:word;
     sizex,sizey:byte;
  begin
    sizex:=xsize; sizey:=ysize; sizex2:=xsize;
    qseg:=seg(font[zn]); qofs:=ofs(font[zn]);
    kseg:=seg(cht[0]); kofs:=ofs(cht[0]);
    asm
      push ds
      mov cx,0d     {CX - pocitadlo}
      mov ds,qseg   {ds:si-char table}
      mov si,qofs
      mov di,qx     {es:di-writing position}
      mov bx,kofs
      push es
      mov es,kseg
      mov dh,[es:bx+8] {0 - do not overwrite}
      mov dl,[es:bx+9]
      pop es

@znov:mov ch,0h
      push es
      mov es,kseg
      add bx,cx
      mov al,[es:bx]
      sub bx,cx
      pop es

      mov ah,[ds:si]
      inc si
 @puk:test ah,1d
      jz  @nic

      push ax
      push bx
      push dx
      push cx
      mov cl,al
      mov ax,di
      mov dx,0
      mov bx,320
      div bx
      xchg cx,ax
      xchg dx,cx
      mov ah,0ch
      mov bh,0h
      int 10h
      pop cx
      pop dx
      pop bx
      pop ax

      jmp @dal
 @nic:cmp dh,0h
      je  @dal

      push ax
      push bx
      push dx
      push cx
      mov cl,dl
      mov ax,di
      mov dx,0
      mov bx,320
      div bx
      xchg cx,ax
      xchg dx,cx
      mov ah,0ch
      mov bh,0h
      int 10h
      pop cx
      pop dx
      pop bx
      pop ax

 @dal:inc di
      shr ah,1
      inc ch
      cmp ch,sizex
      jne @puk

      add di,scrsize
      sub di,sizex2
      inc cl
      cmp cl,sizey
      jne @znov

      pop ds
    end;
  end;

{VYPISUJE STRING}
procedure etext(x:word;s:string);
  var i:integer;
  begin
    for i:=1 to length(s) do begin
      eypis(x,ord(s[i]));
      inc(x,xsize);
    end;
  end;

  procedure winfill(adr,sizex,sizey:word;col:byte);
    begin
      case card of
        0:bwinfill(adr,sizex,sizey,col);
        1:begin
          setcolor(0); setfillstyle(1,0);
          bar(adr mod 320,adr div 320,adr mod 320+sizex-1,adr div 320+sizey-1);
          setcolor(7);
          rectangle(adr mod 320,adr div 320,adr mod 320+sizex-1,adr div 320+sizey-1);
        end;
      end;
    end;

  procedure paint(adr:word;co:integer);
    begin
      case card of
        0:bpaint(adr,pic[co]);
        1:epaint(adr,pic[co]);
      end;
    end;

  procedure xpaint(adr:word;co:integer;col,curn:byte);
    begin
      case card of
        0:bxpaint(adr,pic[co],col,curn);
        1:begin 
		  expaint(adr,pic[co],0,curn);
          setcolor(7);
          rectangle(adr mod 320,adr div 320,adr mod 320+10-1,adr div 320+10-1);
        end;
      end;
    end;

  procedure text(adr:word;s:string);
    var i:integer;
    begin
      case card of
        0:begin 
          for i:=0 to 7 do cht[i]:=cht[i] xor 8;
		  btext(adr,s);
          for i:=0 to 7 do cht[i]:=cht[i] xor 8;
		  btext(adr+1,s);
        end;
        1:begin
          for i:=0 to 7 do cht[i]:=cht[i] xor 8;
		  etext(adr,s);
          for i:=0 to 7 do cht[i]:=cht[i] xor 8;
		  etext(adr+1,s);
        end;
      end;
    end;

  procedure ClearScreen;
    begin
      case card of
        0:bclearpage;
        1:begin 
		  ClearDevice;
          setcolor(7);
          rectangle(0,0,319,199);
        end;
      end;
    end;

  procedure lin(x1,y1,x2,y2:integer;col:byte);
    begin
      case card of
        0:bline(x1,y1,x2,y2,col);
        1:begin
          setcolor(col);
          line(x1,y1,x2,y2);
        end;
      end;
    end;



  begin
  end.
